; CrASH/CrASH19006/Venus 2.3/ION 1.6 Include fileheader by Guillaume Hoffmann
; for TPASM, it will NOT work with TASM
;
;
; REVISION 7 - 02/11/2003
;
;
; How to use this header :
;
;+----------------------------------+
;| INCLUDE "Vion.inc"		    |
;|	db "Program title",0	    |
;|start				    |
;|	[...]	; program code here |
;|	ret			    |
;+----------------------------------+
;
; Labels you have to define:
;TI82
;CRASH
;CRASH19006
;TI83
;TI83P
;
;----> Safe Memory Areas (TI83(+))
; saferam1 = 768 bytes (apdram)
; saferam2 = 531 bytes (statram)
; saferam3 = 128 bytes (textmem)
; saferam4 = 66 bytes (ops)
; saferam5 = 10 bytes (imathptrs)

 NOLIST

 IFDEF	TI83

bcall MACRO xxxx
 call xxxx
 ENDM

bcallz MACRO xxxx
 call z,xxxx
 ENDM

bcallnz MACRO xxxx
 call nz,xxxx
 ENDM

bcallc MACRO xxxx
 call c,xxxx
 ENDM

bcallnc MACRO xxxx
 call nc,xxxx
 ENDM

bjp MACRO xxxx
 jp xxxx
 ENDM

icall MACRO xxxx
 call xxxx
 ENDM

ijp MACRO xxxx
 jp xxxx
 ENDM


vRandom		equ $FE72	;
FastCopy	equ $FE75	; Venus routines


_enoughmem	equ 443Ah

_ldhlind	equ 4000h
_cphlde		equ 4004h
_divhlby10	equ 4008h
_divhlbya	equ 400Ch
_getcsc		equ 4014h
_lcdbusy	equ 4066h
_htimesl	equ 4382h	; hl=h*l (error if overflow)
usermemoff	equ 8565h
progstart	equ 9327h
libstart	equ 0002h
saferam1	equ 8265h
saferam2	equ 858Fh
saferam3	equ 80C9h
saferam4	equ 8039h
_homeup		equ 4775h
_newline	equ 473Dh
_darkline	equ 4AE0h
_indicatorOff	equ 4795h
_indicatorOn	equ 4791h
_cleargbuf	equ 515Bh
_copygbuf	equ 4B9Ch
_clrlcdf	equ 4755h
_cleartextshad	equ 4765h
_clrscr		equ 4759h
_clrscrf	equ 475Dh
_iline		equ 4AE4h
_ipoint		equ 4AE8h
_disphl		equ 4709h
_hltimes9	equ 4146h
_vputmap	equ 477Dh
_vputs		equ 4781h
_vputsn		equ 4785h
_putmap		equ 4701h
_puts		equ 470Dh
_putps		equ 4715h
_putc		equ 4705h
_getkey		equ 4CFEh
_getk		equ 4A18h
_rcly		equ 4EE0h
_rclx		equ 4EE8h
_memfree	equ 441Ah
_chksysvar	equ 442Ah
_findsym	equ 442Eh
_creategdb	equ 4486h
_createprog	equ 448Ah
_createreal	equ 4452h
_createstring	equ 4472h
_delvar		equ 44AAh
_insertmem	equ 4432h
_deletemem	equ 44B2h
op1		equ 8039h
op2		equ 8044h
op3		equ 804Fh
op4		equ 805Ah
op5		equ 8065h
op6		equ 8070h
imathptr1	equ 8094h
imathptr2	equ 8096h
imathptr3	equ 8098h
imathptr4	equ 809Ah
imathptr5	equ 809Ch
progptr		equ 9319h
cmdshad		equ 9157h
plotsscreen	equ 8E29h
symtable	equ $FE6E
currow		equ 800Ch
curcol		equ 800Dh
pencol		equ 8252h
penrow		equ 8253h
curgy		equ 886Dh
curgx		equ 886Eh
contrast	equ $8008


FREE_MEM_START  equ $930D
FREE_MEM_END	equ $9311


; Some equates to help port

grbuf		equ plotsscreen
graph_mem	equ plotsscreen
GRAPH_MEM	equ plotsscreen
gbuf		equ plotsscreen
sram		equ saferam1
apdram		equ saferam1
APD_BUF		equ saferam1
savesscreen	equ saferam1
statram		equ saferam2
statvars	equ saferam2
vat		equ progptr
saferam5	equ imathptr1
TEXT_MEM	equ saferam3

GET_KEY		equ _getcsc
_clrtextshad	equ _cleartextshad
_grbufclr	equ _cleargbuf
_bufclr		equ _cleargbuf
_clrlcdfull	equ _clrlcdf
_clrscrnfull	equ _clrscrf
_bufcopy	equ _copygbuf
_grbufcpy	equ _copygbuf

 ENDIF



 IFDEF	TI83P

bcall MACRO xxxx
 rst 28h
 dw xxxx
 ENDM

bcallz MACRO xxxx
 jr nz,$+5
 rst 28h
 dw xxxx
 ENDM

bcallnz MACRO xxxx
 jr z,$+5
 rst 28h
 dw xxxx
 ENDM

bcallc MACRO xxxx
 jr nc,$+5
 rst 28h
 dw xxxx
 ENDM

bcallnc MACRO xxxx
 jr c,$+5
 rst 28h
 dw xxxx
 ENDM

bjp MACRO xxxx
 bcall xxxx
 ret
 ENDM

icall MACRO xxxx
 bcall xxxx
 ENDM

ijp MACRO xxxx
 bjp xxxx
 ENDM


_enoughmem	EQU 42FDh

_ldhlind	equ 4009h
_cphlde		equ 400Ch
_divhlby10	equ 400Fh
_divhlbya	equ 4012h
_getcsc		equ 4018h
_lcdbusy	equ 4051h
_hltimes9	equ 40F9h
_htimesl	equ 4276h
_convop1	equ 4AEFh
_darkline	equ $47DD
_darkpoint	equ $47F2
appBackupScreen	equ $9872	; 768 bytes
tempSwapArea	equ $82A5
usermemoff	equ $89EC
libstart	equ $0004
progstart	equ 9D95h

saferam1	equ 86ECh
saferam2	equ 8A3Ah
saferam3	equ 8508h
saferam4	equ 8478h

_homeup		equ $4558
_newline	equ $452E
_cleargbuf	equ 4BD0h
_indicatorOn	equ 456Dh
_indicatorOff	equ 4570h
_copygbuf	equ 486Ah
_clrlcdf	equ 4540h
_cleartextshad	equ 454Ch
_clrscr		equ 4543h
_clrscrf	equ 4546h
_iline		equ 47E0h
_ipoint		equ 47E3h
_disphl		equ 4507h
_vputmap	equ 455Eh
_vputs		equ 4561h
_vputsn		equ 4564h
_putmap		equ 4501h
_puts		equ 450Ah
_putps		equ 4510h
_putc		equ 4504h
_getkey		equ 4972h
_getk		equ 4744h
_rclx		equ $4AE0
_rcly		equ $4ADA
_memfree	equ $42E5
_chksysvar	equ 42F1h
_findsym	equ 42F4h
;_CREATEGDB	equ 4486h
_createreal	equ $430F
_createstring	equ $4327
_createprog	equ $4339
_createprotprog	equ $4E6D
_delvar		equ 4351h
_insertmem	equ 42F7h
_deletemem	equ 4357h
op1		equ 8478h
op2		equ 8483h
op3		equ 8499h
op4		equ 8499h
op5		equ 84A4h
op6		equ 84AFh
imathptr1	equ 84D3h
imathptr2	equ 84D5h
imathptr3	equ 84D7h
imathptr4	equ 84D9h
imathptr5	equ 84DBh
progptr		equ 9830h
cmdshad		equ 966Eh
plotsscreen	equ 9340h
symtable	equ $FE6E
currow		equ 844Bh
curcol		equ 844Ch
pencol		equ 86D7h
penrow		equ 86D8h
curgy		equ 8D18h
curgx		equ 8D19h
contrast	equ 8447h

FREE_MEM_START	equ $9824
FREE_MEM_END	equ $9828

;-----> Ion Functions
lVectors	equ cmdshad+80
ionVersion	equ lVectors
ionRandom	equ lVectors+3
ionPutSprite	equ lVectors+6
ionLargeSprite	equ lVectors+9
ionGetPixel	equ lVectors+12
FastCopy	equ lVectors+15
ionDetect	equ lVectors+18
ionDecompress	equ lVectors+21


; Some equates to help port

grbuf		equ plotsscreen
graph_mem	equ plotsscreen
GRAPH_MEM	equ plotsscreen
gbuf		equ plotsscreen
sram		equ saferam1
apdram		equ saferam1
APD_BUF		equ saferam1
savesscreen	equ saferam1
statram		equ saferam2
statvars	equ saferam2
vat		equ progptr
saferam5	equ imathptr1
TEXT_MEM	equ saferam3

GET_KEY		equ _getcsc
_clrtextshad	equ _cleartextshad
_grbufclr	equ _cleargbuf
_bufclr		equ _cleargbuf
_clrlcdfull	equ _clrlcdf
_clrscrnfull	equ _clrscrf
_bufcopy	equ _copygbuf
_grbufcpy	equ _copygbuf

 ENDIF


 IFDEF TI82

ptemp equ $8D18

ApdSubTimer equ $8009
ApdTimer equ $800A


 IFDEF CRASH19006
;
; CRASH19006.INC for CrASH
;  made by Hideaki Omuro and Jeff Mears
; modifi le 22/04/2003 pour CrASH_19006 par Jumbo (www.PlaneteTI82.fr.st)
;
;

;
; RAM Locations
;
;Name         Address Len  Meaning
;   
KEY_0        equ $8000 ;Byte Scancode of last key, 0 if gotten
KEY_1        equ $8001 ;Byte Scancode of key down now
KEY_2        equ $8002 ;Byte Same as $8001, $FF if more than one key is down
KEY_STAT     equ $8004 ;Byte Bit 2 set = key down now
LAST_KEY     equ $8006 ;Byte Last key pressed
CONTRAST     equ $8008 ;Byte Contrast ($00 to $1F)
CURSOR_POS   equ $800C ;Word Text position for word operations
CURSOR_ROW   equ $800C ;Byte Text cursor row
CURSOR_COL   equ $800D ;Byte Text cursor column
BUSY_COUNTER equ $8026 ;Byte Counter for busy indicator
BUSY_BITMAP  equ $8027 ;Byte Bitmap for busy indicator
OP1          equ $8028 ;  11 OP1
OP2          equ $8033 ;  11 OP2
OP3          equ $803E ;  11 OP3
OP4          equ $8049 ;  11 OP4
OP5          equ $8054 ;  11 OP5
OP6          equ $805F ;  11 OP6
TEXT_MEM     equ $808F ; 128 text memory
GRAF_CURS    equ $8215 ;Word Cursor position for graphics
CURSOR_X     equ $8215 ;Byte X value of graphics cursor
CURSOR_Y     equ $8216 ;Byte Y value of graphics cursor
APD_BUF      equ $8228 ; 768 APD screen buffer
_IY_TABLE    equ $8528 ; N/A Where IY usually points
GRAPH_MEM    equ $88B8 ; 768 Graphics Buffer
TEXT_MEM2    equ $8BDF ; 128 Secondary text memory
WIN_START    equ $8C8F ;Byte Number of first row in window
WIN_END      equ $8C90 ;Byte Number of last row in window
CRASH_VER    equ $8D73 ;Byte Version number of CrASH
VAT_START    equ $FE6E ; N/A Start of VAT

; The following will be used in programs using the APD buffer.  If something
; important (ie. interrupt) is going on inside APD_BUF, INT_STATE will not
; be 00. (Look in CrASHprg.TXT for details)
APD_FREE     equ $8D70 ;Word Public Free Mem of APD_BUF ($000=none, other=using)
INT_STATE    equ $8D72 ;Byte Public Stat of Interrupts (00=none, other=using)

;
; Variable Regions
;
; You can allocate memory freely in FREE_A regions.
; You must be careful to not use FREE_B if your program calls CR_KHAND

;Free Memory Regions Len Comments
;  
FREE_A1 equ GRAPH_MEM ;768 Cleared when starting a program
FREE_A2 equ TEXT_MEM  ;128 Cleared when starting a program
FREE_A3 equ OP1       ; 66 Can be used if only using normal ROM_CALLs
FREE_B  equ TEXT_MEM2 ;128 Cleared after calling CR_KHAND
FREE_C  equ APD_BUF   ;768 If INT_STATE is not 0, check for available APD_FREE


;
; CrASH call Addresses (use CALL)
;
; This is a list of useful functions created by the authors of CrASH.  They
; are embedded into CrASH, and are very useful tools.

; Use CALL to call these functions.

EXIT_2_TIOS  equ $8D88 ; Exits to TI-OS with a clear screen. (can use JP)
RAND         equ $8D8B ; Returns a random number 0-127 in A.
CP_HL_BC     equ $8D8E ; Compares HL and BC, like CP_HL_DE
CR_KHAND     equ $8D91 ; Key_Hand; does not crash if turned off
CR_GRBCopy   equ $8D94 ; Fast copy to LCD - Read below

; CR_GRBCopy is limited:
;  May not work correctly if LCD_Port is set to go auto right
;  May not work correctly if calc is turboed
;  Only copies from GRAPH_MEM
;  Still testing - please report bugs while using it.

;
; ROM Addresses (use CALL)
;
; This is a list of useful functions inside the TI-82's ROM.

; Use CALL to call these functions.

;AddressName  Address Registers Description
;   
LD_HL_MHL    equ $0033 ;HLA       HL=(HL), A=L
CP_HL_DE     equ $0095 ;F         CP  HL, DE
UNPACK_HL    equ $00A1 ;HLA       HL=int(HL/10), A=HL MOD 10
DIV_HL_A     equ $00A3 ;HLA       HL=int(HL/A), A=HL MOD A
KEY_READ     equ $01D7 ;$01B8	;AB        Does raw keyboard read with mask A; returns A
STORE_KEY    equ $01E6 ;$01C7	;?         Store keystroke from A
GET_KEY      equ $01F3 ;$01D4	;HL?       Get immediate keystroke into A
DISP_DELAY   equ $083A ;$07F3	;          Delay for display controller      (60 clocks)
FIND_PIXEL   equ $4166 ;?         Find pixel (rom page must be 4) !? Somebody uses that ???



;
; ROM Offset Addresses (use ROM_CALL)
;
; To use functions not included here just make a definition like the ones
; below in your program (not recommended).  If you are using the addresses
; in rom found by another source for rom version 19, remember to subtract $1A
; from that address.  (The ones listed are roms version 16-18)

; Use ROM_CALL to call these functions.


ROM_CALL MACRO xxxx
 call xxxx
 ENDM

bcall MACRO xxxx
 call xxxx
 ENDM

bjp MACRO xxxx
 jp xxxx
 ENDM

icall MACRO xxxx
 call xxxx
 ENDM

ijp MACRO xxxx
 jp xxxx
 ENDM

TR_CHARPUT   equ $387D	;$3738 ; Raw display of A on screen, normal text style
TX_CHARPUT   equ $3B35	;$39D2 ; Xlated display of A on screen, normal text style
D_ZT_STR     equ $3A2D	;$38FA ; Display zero-terminated normal text string
D_LT_STR     equ $3883	;$373E ; Display length-byte normal text string
D_HL_DECI    equ $39AF	;$387C ; Disp HL as 5-char, right just., blank-pad. integer
LAST_LINE    equ $38B9	;$3774 ; Is it the last line?
NEXT_LINE    equ $38BF	;$377A ; Goto next line (might scroll)
SCROLL_UP    equ $38CB	;$3786 ; Scroll text screen up
UP_TEXT      equ $392B	;$37F2 ; Update text mem from command shadow

M_CHARPUT    equ $3907	;$37CE ; Display %A on screen, menu style
D_ZM_STR     equ $390D	;$37D4 ; Display zero-terminated string, menu style
D_LM_STR     equ $3913	;$37DA ; Display length indexed string, menu style

CLEARLCD     equ $39CD	;$389A ; Clear LCD, but not text or graphics memory
CLEARTEXT_W  equ $3A45	;$37B0 ; Clear LCD and text memory, but only current window (affected by 1,(IY+13))
CLEARTEXT_F  equ $38E9	;$37A4 ; Clear LCD and text memory (affected by 1,(IY+13))
CLEAR_DISP   equ $39F1	;$38CA ; Clear display
BACKUP_DISP  equ $3B29	;$39C6 ; Copy display to APD_BUF
RESTOR_DISP  equ $3A09	;$38DC ; Copy APD_BUF to display



; In OShell-82, two of these ROM functions are called by the TI-83 name which
; TI gave them.  To make easier for TI-83 programmers, the following two
; definitions are included, although NOT recommended for usage AT ALL.
;                                                           
; Also, there are alternate CrASH calls that will do the same thing, but
; enhanced.  (Look above)

DISP_GRAPH   equ $39DF	;$38AC ; Display contents of GRAPH_MEM on LCD
KEY_HAND     equ $3A87	;$3924 ; Get key using key handler (2nd, alpha, contrast)

;
; Ports
;
P_LINK       equ $00   ; Link port                                     (TI-85)
P_KEYBOARD   equ $01   ; Port used to access keys                      (TI-85)
P_ROM        equ $02   ; Rom page switching and other things
P_STATUS     equ $03   ; Used to get/set status of varius hardware
P_INT        equ $04   ; Interrupt speed (don't change!!! the display needs it)
P_LCD_CON    equ $10   ; Control port for display controller           (TI-83)
P_LCD_DATA   equ $11   ; Data port for display controller              (TI-83)

START_ADDR equ $9104
 ENDIF


 IFDEF CRASH

;
; CRASH82.INC for CrASH v1.1
;  made by Hideaki Omuro and Jeff Mears
;

;
; RAM Locations
;
;Name         Address Len  Meaning
;   
KEY_0        equ $8000 ;Byte Scancode of last key, 0 if gotten
KEY_1        equ $8001 ;Byte Scancode of key down now
KEY_2        equ $8002 ;Byte Same as $8001, $FF if more than one key is down
KEY_STAT     equ $8004 ;Byte Bit 2 set = key down now
LAST_KEY     equ $8006 ;Byte Last key pressed
CONTRAST     equ $8008 ;Byte Contrast ($00 to $1F)
CURSOR_POS   equ $800C ;Word Text position for word operations
CURSOR_ROW   equ $800C ;Byte Text cursor row
CURSOR_COL   equ $800D ;Byte Text cursor column
BUSY_COUNTER equ $8026 ;Byte Counter for busy indicator
BUSY_BITMAP  equ $8027 ;Byte Bitmap for busy indicator
OP1          equ $8028 ;  11 OP1
OP2          equ $8033 ;  11 OP2
OP3          equ $803E ;  11 OP3
OP4          equ $8049 ;  11 OP4
OP5          equ $8054 ;  11 OP5
OP6          equ $805F ;  11 OP6
TEXT_MEM     equ $808F ; 128 text memory
GRAF_CURS    equ $8215 ;Word Cursor position for graphics
CURSOR_X     equ $8215 ;Byte X value of graphics cursor
CURSOR_Y     equ $8216 ;Byte Y value of graphics cursor
APD_BUF      equ $8228 ; 768 APD screen buffer
_IY_TABLE    equ $8528 ; N/A Where IY usually points
GRAPH_MEM    equ $88B8 ; 768 Graphics Buffer
TEXT_MEM2    equ $8BDF ; 128 Secondary text memory
WIN_START    equ $8C8F ;Byte Number of first row in window
WIN_END      equ $8C90 ;Byte Number of last row in window
CRASH_VER    equ $8D73 ;Byte Version number of CrASH
VAT_START    equ $FE6E ; N/A Start of VAT

; The following will be used in programs using the APD buffer.  If something
; important (ie. interrupt) is going on inside APD_BUF, INT_STATE will not
; be 00. (Look in CrASHprg.TXT for details)
APD_FREE     equ $8D70 ;Word Public Free Mem of APD_BUF ($000=none, other=using)
INT_STATE    equ $8D72 ;Byte Public Stat of Interrupts (00=none, other=using)

;
; Variable Regions
;
; You can allocate memory freely in FREE_A regions.
; You must be careful to not use FREE_B if your program calls CR_KHAND

;Free Memory Regions Len Comments
;  
FREE_A1 equ GRAPH_MEM ;768 Cleared when starting a program
FREE_A2 equ TEXT_MEM  ;128 Cleared when starting a program
FREE_A3 equ OP1       ; 66 Can be used if only using normal ROM_CALLs
FREE_B  equ TEXT_MEM2 ;128 Cleared after calling CR_KHAND
FREE_C  equ APD_BUF   ;768 If INT_STATE is not 0, check for available APD_FREE


;
; CrASH call Addresses (use CALL)
;
; This is a list of useful functions created by the authors of CrASH.  They
; are embedded into CrASH, and are very useful tools.

; Use CALL to call these functions.

EXIT_2_TIOS  equ $8D88 ; Exits to TI-OS with a clear screen. (can use JP)
RAND         equ $8D8B ; Returns a random number 0-127 in A.
CP_HL_BC     equ $8D8E ; Compares HL and BC, like CP_HL_DE
CR_KHAND     equ $8D91 ; Key_Hand; does not crash if turned off
CR_GRBCopy   equ $8D94 ; Fast copy to LCD - Read below


; CR_GRBCopy is limited:
;  May not work correctly if LCD_Port is set to go auto right
;  May not work correctly if calc is turboed
;  Only copies from GRAPH_MEM
;  Still testing - please report bugs while using it.

;
; ROM Addresses (use CALL)
;
; This is a list of useful functions inside the TI-82's ROM.

; Use CALL to call these functions.

;AddressName  Address Registers Description
;   
LD_HL_MHL    equ $0033 ;HLA       HL=(HL), A=L
CP_HL_DE     equ $0095 ;F         CP  HL, DE
UNPACK_HL    equ $00A1 ;HLA       HL=int(HL/10), A=HL MOD 10
DIV_HL_A     equ $00A3 ;HLA       HL=int(HL/A), A=HL MOD A
KEY_READ     equ $01B8 ;AB        Does raw keyboard read with mask A; returns A
STORE_KEY    equ $01C7 ;?         Store keystroke from A
GET_KEY      equ $01D4 ;HL?       Get immediate keystroke into A
DISP_DELAY   equ $07F3 ;          Delay for display controller      (60 clocks)
FIND_PIXEL   equ $4166 ;?         Find pixel (rom page must be 4)


;
; ROM Offset Addresses (use ROM_CALL)
;
; To use functions not included here just make a definition like the ones
; below in your program (not recommended).  If you are using the addresses
; in rom found by another source for rom version 19, remember to subtract $1A
; from that address.  (The ones listed are roms version 16-18)

; Use ROM_CALL to call these functions.

ROM_CALL MACRO xxxx
 call $8D74
 dw xxxx
 ENDM

bcall MACRO xxxx
 call $8D74
 dw xxxx
 ENDM

bjp MACRO xxxx
 bcall xxxx
 ret
 ENDM

icall MACRO xxxx
 call xxxx
 ENDM

ijp MACRO xxxx
 jp xxxx
 ENDM


TR_CHARPUT   equ $3738 ; Raw display of A on screen, normal text style
TX_CHARPUT   equ $39D2 ; Xlated display of A on screen, normal text style
D_ZT_STR     equ $38FA ; Display zero-terminated normal text string
D_LT_STR     equ $373E ; Display length-byte normal text string
D_HL_DECI    equ $387C ; Disp HL as 5-char, right just., blank-pad. integer
LAST_LINE    equ $3774 ; Is it the last line?
NEXT_LINE    equ $377A ; Goto next line (might scroll)
SCROLL_UP    equ $3786 ; Scroll text screen up
UP_TEXT      equ $37F2 ; Update text mem from command shadow


; "Menu style" is actually just a bad way of saying "small font"
M_CHARPUT    equ $37CE ; Display %A on screen, small font
D_ZM_STR     equ $37D4 ; Display zero-terminated string, small font
D_LM_STR     equ $37DA ; Display length indexed string, small font


CLEARLCD     equ $389A ; Clear LCD, but not text or graphics memory
CLEARTEXT_W  equ $37B0 ; Clear LCD and text memory, but only current window (affected by 1,(IY+13))
CLEARTEXT_F  equ $37A4 ; Clear LCD and text memory (affected by 1,(IY+13))
CLEAR_DISP   equ $38CA ; Clear display
BACKUP_DISP  equ $39C6 ; Copy display to APD_BUF
RESTOR_DISP  equ $38DC ; Copy APD_BUF to display

;_GrbufClr equ CLEAR_DISP
;_cleargbuf equ CLEAR_DISP

; In OShell-82, two of these ROM functions are called by the TI-83 name which
; TI gave them.  To make easier for TI-83 programmers, the following two
; definitions are included, although NOT recommended for usage AT ALL.
;                                                           
; Also, there are alternate CrASH calls that will do the same thing, but
; enhanced.  (Look above)

DISP_GRAPH   equ $38AC ; Display contents of GRAPH_MEM on LCD
KEY_HAND     equ $3924 ; Get key using key handler (2nd, alpha, contrast)



;
; Misc
;
TEXT_START MACRO
 res 1,(iy+0Dh)
 res 2,(iy+0Dh)
 ROM_CALL CLEAR_DISP
 ld hl,0000h
 ld (CURSOR_POS),hl
 ENDM

TEXT_END MACRO
 set 2,(iy+0Dh)
 set 1,(iy+0Dh)
 ENDM

START_ADDR equ $9104

 ENDIF

LAST_BYTE_USED_MEM equ $8D0E ;Word 8D0E Pointer to last byte of used mem (init to 8D24) Pointer to last byte of used mem

;**************
; TI83 equates
;**************

FastCopy equ CR_GRBCopy	; my favorite :)

_disphl equ D_HL_DECI
_puts equ D_ZT_STR
_newline equ NEXT_LINE
_putc equ TX_CHARPUT

_vputs equ D_ZM_STR
_vputmap equ M_CHARPUT

_clrlcdfull equ CLEARLCD
_clrlcdf equ CLEARLCD

_grbufcpy    equ DISP_GRAPH ; Way too slow
_grbufcpy_v  equ DISP_GRAPH ; Way too slow
;_GETKEY      equ KEY_HAND   ; Crashes when you turn off calc. (not a joke)


_getkey equ CR_KHAND
_ldhlind equ LD_HL_MHL
_cphlde equ CP_HL_DE
_divhlby10 equ UNPACK_HL
_divhlbya equ DIV_HL_A
_getcsc equ GET_KEY
_lcdbusy equ DISP_DELAY
_clrscrnfull equ CLEARTEXT_F


plotsscreen equ GRAPH_MEM
savesscreen equ APD_BUF
textshadow equ TEXT_MEM
cmdshadow equ TEXT_MEM2
currow equ CURSOR_ROW
curcol equ CURSOR_COL
pencol equ CURSOR_X
penrow equ CURSOR_Y
symtable equ VAT_START
indicbusy equ BUSY_BITMAP
statvars equ cmdshadow
op1 equ OP1
op2 equ OP2
op3 equ OP3
op4 equ OP4
op5 equ OP5
op6 equ OP6
contrast equ CONTRAST

saferam1	equ APD_BUF	; can't really be used with CrASH...
saferam2	equ TEXT_MEM2
saferam3	equ TEXT_MEM
saferam4	equ OP1

gbuf equ plotsscreen
grbuf equ plotsscreen
sram equ saferam1
apdram equ saferam1
statram equ saferam2
cmdshad equ cmdshadow



progstart equ START_ADDR

 ENDIF



;-------
; Ports
;-------

lcdinstport	equ	$10
lcddataport	equ	$11


;----------------------------------------------------------------------
;           System and State Flags (common for ti-82/83(+))
;----------------------------------------------------------------------


iodelflag	EQU	0
indelete	EQU	0	;1 = DELETE SCREEN

trigflags	EQU	0	;Trigonometry mode settings
trigdeg 	EQU	2	; 1=degrees, 0=radians

kbdflags	EQU	0	;Keyboard scan
kbdDCR		EQU	3	;1=scan code ready
kbdKeyPress	EQU	4	; 1=key has been pressed

doneflags	EQU	0	;display "Done"
doneprgm	EQU	5	; 1=display "Done" after prgm



;----------------------------------------------------------------------
editflags	EQU	1
editopen	EQU	2	; 1=edit buffer is open

monflags	EQU	1	;monitor flags
monabandon	EQU	4	; 1=don't start any long process
				; in put away (#715)
;----------------------------------------------------------------------
plotflags	EQU	2		;plot generation flags
plottrace	equ	0
plotloc 	EQU	1	; 0=bkup & display, 1=display only
plotdisp	EQU	2	; 1=plot is in display, 0=text in display


grfModeFlags	EQU	2		;graph mode settings
grfFuncM	EQU	4	; 1=function graph
grfPolarM	EQU	5	; 1=polar graph
grfParamM	EQU	6	; 1=parametric graph
grfRecurM       EQU	7        ; 1=RECURSION graph

graphFlags	EQU	3
graphDraw	EQU	0	; 0=graph is valid, 1=redraw graph

grfDBFlags	EQU	4
grfDot		EQU	0	; 0=line, 1=dot
grfSimul	EQU	1	; 0=sequential, 1=simultaneous
grfGrid 	EQU	2	; 0=no grid, 1=grid
grfPolar	EQU	3	; 0=rectangular, 1=polar coordinates
grfNoCoord	EQU	4	; 0=display coordinates, 1=off
grfNoAxis	EQU	5	; 0=axis, 1=no axis
grfLabel	EQU	6	; 0=off, 1=axis label

textflags	EQU	5		;Text output flags
texterasebelow	EQU	1	; 1=erase line below small char
textscrolled	EQU	2	; 1=screen scrolled
textinverse	EQU	3	; 1=display inverse bit-map
textinsmode	EQU	4	; 0=overstrike, 1=insert mode

ParsFlag2	EQU	7		;PARSER flags
numOP1		EQU	0	; 1=RESULT IN OP1, 0=NO RESULT

newDispF        EQU	8		;Derivative mode flags
preClrForMode   EQU	0	; 1=HELP BLINK ON MODE SCREEN

apdFlags	EQU	8		;Automatic power-down
apdAble 	EQU	2	; 1=APD enabled
apdRunning	EQU	3	; 1=APD clock running

onflags 	EQU	9		;on key flags
onrunning	EQU	3	; 1 = calculator is running
oninterrupt	EQU	4	; 1=on key interrupt request

statFlags	EQU	9		;statistics flags
statsValid	EQU	6	; 1=stats are valid
statANSDISP	EQU	7	; 1=display stat results

fmtFlags	EQU	10		;numeric format flags
fmtExponent	EQU	0	; 1=show exponent, 0=no exponent
fmtEng		EQU	1	; 1=engineering notion, 0=scientific
fmtHex		EQU	2	; 1=hexadecimal
fmtOct		EQU	3	; 1=octal
fmtBin		EQU	4	; 1=binary

numMode         EQU	10
fmtReal         EQU	5
realMode        EQU	5
fmtRect         EQU	6
rectMode        EQU	6
fmtPolar        EQU	7
polarMode       EQU	7



web_err_mask    EQU  60h

;					;   if Hex and Oct both = 1
;					;   then Bin=0 means >Frac
;					;	 Bin=1 means >DMS
fmtBaseMask     EQU  %00011100		; mask to base flags
fmtBaseShift    EQU  2			; offset to base flags


fmtOverride	EQU  11		;copy of fmtFlags with conversion override

fmtEditFlags	EQU  12		;numeric editing flags
fmtEdit 	EQU    0	; 1=format number for editing

curFlags	EQU  12		;Cursor
curAble 	EQU    2	; 1=cursor flash is enabled
curOn		EQU    3	; 1=cursor is showing
curLock 	EQU    4	; 1=cursor is locked off

appflags	EQU  13		;application flags
appwantintrpt	EQU    0		; 1=want ON key interrupts
apptextsave	EQU    1		; 1=save characters in textShadow
appautoscroll	EQU    2		; 1=auto-scroll text on last line
appmenus	EQU    3		; 1=process keys that bring up menus
					; 0=check Lock menu flag
applockmenus	EQU    4		; 1=ignore menu keys
					; 0=switch to home screen and bring up menu
appcurgraphic	EQU    5		; 1=graphic cursor
appcurword	EQU    6		; 1=text cursor covers entire word
appexit 	EQU    7		; 1=application handles [EXIT] key itself

appwantintrptf	EQU	1<<appwantintrpt
apptextsavef	EQU	1<<apptextsave
appautoscrollf	EQU	1<<appautoscroll
appmenusf	EQU	1<<appmenus
applockmenusf	EQU	1<<applockmenus
appcurgraphicf	EQU	1<<appcurgraphic
appcurwordf	EQU	1<<appcurword
appexitf	EQU	1<<appexit


seqFlags        EQU	15              ; Sequential Graph flags
webMode         EQU	0             ; 0 = NORMAL SEQ MODE, 1 = WEB MODE
webVert         EQU	1             ;
sequv           EQU	2             ; U vs V
seqvw           EQU	3             ; V vs W
sequw           EQU	4             ; U vs W


promptFlags	EQU	17;prompt line flags
promptEdit	EQU    0	; 1=editing in prompt buffer

indicFlags	EQU	18	;Indicator flags
indicRun	EQU    0	; 1=run indicator ON
indicInUse	EQU    1	; indicator save area in use=1, free=0
indicOnly	EQU    2	; interrupt handler only checks run indicator

shiftFlags	EQU	18	;[2nd] and [ALPHA] flags
shift2nd	EQU    3	; 1=[2nd] has been pressed
shiftAlpha	EQU    4	; 1=[ALPHA] has been pressed
shiftLwrAlph	EQU    5	; 1=lower case, 0=upper case
shiftALock	EQU    6	; 1=alpha lock has been pressed
shiftKeepAlph	EQU    7	; 1=cannot cancel alpha shift


tblFlags        EQU	19		;table flags.
autoFill	EQU	4	; 1=prompt, 0=fillAuto
autoCalc	EQU	5	; 1=prompt, 0=CalcAuto
reTable		EQU	6	; 0=table is ok, 1=must recompute table.

sgrflags	EQU	20
grfsplit	EQU	0	; 1=Split Graph, 0=Normal
vertsplit	EQU	1	; 1=Vertical (left-right) Split
grfschanged	EQU	2	; 1=Graph just changed Split <-> normal
grfsplitoverride EQU	3	; 1 = ignore graph split flag if set
write_on_graph	EQU	4	; 1 = TEXT OR EQU WRITING TO GRAPH SCREEN
g_style_active	EQU	5	; 1 = GRAPH STYLES ARE ENABLED, USE THEM
cmp_mod_box	EQU	6	; 1 = DOING MOD BOX PLOT COMPUTATION
textwrite	EQU	7	; 1 = Small font writes to buffer
				; 0 = Small font writes to display
;

newindicflags	EQU	21
extraindic	EQU	0
saindic		EQU	1

newflags2	EQU	22
norestores	EQU	5

smartflags	EQU	23
;
;----------------------------------------------------------------------
; Note: Fix these Equates if smartFlags are moved
;----------------------------------------------------------------------
;
smarter_mask    EQU  3
smarter_test    EQU  1
smartgraph      EQU  0
smartgraph_inv  EQU  1

more_flags	EQU 26

no_del_stat	EQU 2
;----------------------------------------------------------------------
;           Available for ASM programming
;----------------------------------------------------------------------

asm_flag1       EQU  33          ; ASM CODING
asm_flag2       EQU  34          ; ASM CODING
asm_flag3       EQU  35          ; ASM CODING




;############################
;##     Getcsc/Getk Keys   ##
;############################

G_NONE   equ  $00
G_DOWN   equ  $01
G_LEFT   equ  $02
G_RIGHT  equ  $03
G_UP     equ  $04
G_ENTER  equ  $09
G_PLUS   equ  $0A
G_MINUS  equ  $0B
G_TIMES  equ  $0C
G_DIV    equ  $0D
G_CARROT equ  $0E
G_CLEAR  equ  $0F
G_NEG    equ  $11
G_3      equ  $12
G_6      equ  $13
G_9      equ  $14
G_PARENR equ  $15
G_TAN    equ  $16
G_VARS   equ  $17
G_PERIOD equ  $19
G_2      equ  $1A
G_5      equ  $1B
G_8      equ  $1C
G_PARENL equ  $1D
G_COS    equ  $1E
G_PRGM   equ  $1F
G_STAT   equ  $20
G_0      equ  $21
G_1      equ  $22
G_4      equ  $23
G_7      equ  $24
G_COMMA  equ  $25
G_SIN    equ  $26
G_MATRIX equ  $27
G_XTO    equ  $28
G_ON     equ  $29
G_STO    equ  $2A
G_LN     equ  $2B
G_LOG    equ  $2C
G_SQR    equ  $2D
G_INVE   equ  $2E
G_MATH   equ  $2F
G_ALPHA  equ  $30
G_GRAPH  equ  $31
G_TRACE  equ  $32
G_ZOOM   equ  $33
G_WINDOW equ  $34
G_YEDIT  equ  $35
G_2ND    equ  $36
G_MODE   equ  $37
G_DEL    equ  $38

K_RIGHT   equ    1 ; RIGHT     RIGHT
K_LEFT    equ    2 ; LEFT      LEFT
K_UP      equ    3 ; UP        UP
K_DOWN    equ    4 ; DOWN      DOWN
K_ENTER   equ    5 ; ENTER     ENTER
K_CLEAR   equ    6 ; CLEAR     CLEAR
K_DEL     equ    7 ; DEL       DEL
K_INS     equ    8 ; DEL       INS
K_RCL     equ    9 ; STO>      RCL
K_ENTRY   equ   10 ; ENTER     ENTRY
K_BOL     equ   11 ; LEFT      BOL
K_EOL     equ   12 ; RIGHT     EOL
K_PRGM    equ   45 ; PRGM      PRGM
K_ZOOM    equ   46 ; ZOOM      ZOOM
K_DRAW    equ   47 ; PRGM      DRAW
K_PLOT    equ   48 ; Yequ         STAT PLOT
K_MATH    equ   49 ; MATH      MATH
K_TEST    equ   50 ; MATH      TEST
K_VARS    equ   52 ; VARS      VARS
K_MEM     equ   53 ; +         MEM
K_MATRIX  equ   54 ; MATRIX    MATRIX
K_STAT    equ   55 ; STAT      STAT
K_YVARS   equ   56 ; VARS      Y-VARS
K_ANGLE   equ   57 ; MATRIX    ANGLE
K_LIST    equ   58 ; STAT      LIST
K_CALC    equ   59 ; TRACE     CALC
K_QUIT    equ   64 ; MODE      QUIT
K_LINK    equ   65 ; X,T,theta LINK
K_GRAPH   equ   69 ; GRAPH     GRAPH
K_MODE    equ   70 ; MODE      MODE
K_WINDOW  equ   73 ; WINDOW    WINDOW
K_YEDIT   equ   74 ; Yequ         Yequ
K_TABLE   equ   75 ; GRAPH     TABLE
K_TBLSET  equ   76 ; WINDOW    TblSet
K_TRACE   equ   93 ; TRACE     TRACE
K_PLUS    equ  129 ; +         +
K_MINUS   equ  130 ; -         -
K_TIMES   equ  131 ; *         *
K_DIV     equ  132 ; /         /
K_POWER   equ  133 ; ^         ^
K_LPAREN  equ  134 ; (         (
K_RPAREN  equ  135 ; )         )
K_LBRACK  equ  136 ; *         [
K_RBRACK  equ  137 ; -         ]
K_STO     equ  139 ; STO>      STO>
K_COMMA   equ  140 ; ,         ,
K_NEG     equ  141 ; (-)       (-)
K_PERIOD  equ  142 ; .         .
K_0       equ  143 ; 0         0
K_1       equ  144 ; 1         1
K_2       equ  145 ; 2         2
K_3       equ  146 ; 3         3
K_4       equ  147 ; 4         4
K_5       equ  148 ; 5         5
K_6       equ  149 ; 6         6
K_7       equ  150 ; 7         7
K_8       equ  151 ; 8         8
K_9       equ  152 ; 9         9
K_EE      equ  153 ; ,         EE
K_SEMI    equ  154 ; 0         ;
K_A       equ  155 ; MATH      A
K_B       equ  156 ; MATRIX    B
K_C       equ  157 ; PRGM      C
K_D       equ  158 ; X^-1      D
K_E       equ  159 ; SIN       E
K_F       equ  160 ; COS       F
K_G       equ  161 ; TAN       G
K_H       equ  162 ; ^         H
K_I       equ  163 ; X^2       I
K_J       equ  164 ; ,         J
K_K       equ  165 ; (         K
K_L       equ  166 ; )         L
K_M       equ  167 ; /         M
K_N       equ  168 ; LOG       N
K_O       equ  169 ; 7         O
K_P       equ  170 ; 8         P
K_Q       equ  171 ; 9         Q
K_R       equ  172 ; *         R
K_S       equ  173 ; LN        S
K_T       equ  174 ; 4         T
K_U       equ  175 ; 5         U
K_V       equ  176 ; 6         V
K_W       equ  177 ; -         W
K_X       equ  178 ; STO>      X
K_Y       equ  179 ; 1         Y
K_Z       equ  180 ; 2         Z
K_XTO     equ  181 ; X,T,theta X,T,theta
K_PI      equ  182 ; ^         Pi
K_INVERSE equ  183 ; X^-1      X^-1
K_SIN     equ  184 ; SIN       SIN
K_ASIN    equ  185 ; SIN       SIN^-1
K_COS     equ  186 ; COS       COS
K_ACOS    equ  187 ; COS       COS^-1
K_TAN     equ  188 ; TAN       TAN
K_ATAN    equ  189 ; TAN       TAN^-1
K_SQR     equ  190 ; X^2       X^2
K_SQRT    equ  191 ; X^2       SQRT
K_LN      equ  192 ; LN        LN
K_EX      equ  193 ; LN        e^X
K_LOG     equ  194 ; LOG       LOG
K_TENP    equ  195 ; LOG       10^X
K_ANS     equ  198 ; (-)       ANS
K_COLON   equ  199 ; .         :
K_QUEST   equ  203 ; (-)       ?
K_QUOTE   equ  204 ; +         "
K_THETA   equ  205 ; 3         THETA
K_LBRACE  equ  237 ; (         {
K_RBRACE  equ  238 ; )         }
K_ABS     equ  244 ; X^-1      ABS
K_L1      equ  245 ; 1         L1
K_L2      equ  246 ; 2         L2
K_L3      equ  247 ; 3         L3
K_L4      equ  248 ; 4         L4
K_L5      equ  249 ; 5         L5
K_L6      equ  250 ; 6         L6
K_Vn1     equ  252 ; 8         Vn-1
K_Un1     equ  253 ; 7         Un-1

;#######################
;## Direct Input Keys ##
;#######################

;Group 1
KeyRow_Pad	equ 0feh
KDown		equ 254
KLeft		equ 253
KRight		equ 251
KUp		equ 247
KIDown		equ 1
KILeft		equ 2
KIRight		equ 4
KIUp		equ 8



;Group 2
KeyRow_5 	equ 0fdh
KEnter		equ 254
KIEnter		equ 1
KPlus		equ 253
KMinus		equ 251
KMul		equ 247
KDiv		equ 239
KPower		equ 223
KClear		equ 191

;Group 3
KeyRow_4 	equ 0fbh
KMinus2		equ 254
KThree		equ 253
KSix		equ 251
KNine		equ 247
KRbracket	equ 239
KTan		equ 223
KVars		equ 191

;Group 4
KeyRow_3	equ 0f7h
KPoint		equ 254
KTwo		equ 253
KFive		equ 251
KEight		equ 247
KLbracket	equ 239
KCos		equ 223
KPrgm		equ 191
KStat		equ 127

;Group 5
KeyRow_2 	equ 0efh
KZero		equ 254
KOne		equ 253
KFour		equ 251
KSeven		equ 247
KComma		equ 239
KSin		equ 223
KMatrx		equ 191
KApps		equ 191
KX		equ 127

;Group 6
KeyRow_1 	equ 0dfh
KOn         equ 254
KSto		equ 253
KLn		equ 251
KLog		equ 247
kX2		equ 239
kX_1		equ 223
kMath		equ 191
kAlpha		equ 127
kIOn    equ 1
kIMath  equ 64
kIAlpha equ 128


;Group 7
KeyRow_Top 	equ 0bfh
KGraph		equ 254
KTrace		equ 253
KZoom		equ 251
KWindow		equ 247
KY		equ 239
k2nd		equ 223
kMode		equ 191
kDel		equ 127

kI2nd equ 32
kIMode equ 64
kIDel equ 128

 LIST

 IFDEF TI83P
	org	progstart-2
	db	$BB,$6D		; ION-compatible program
	ret
	jr	nc,start
 ENDIF

 IFDEF TI83
	org	9329h
	db	"9_[V?",0	; Send(9prgm0V
	jr      nc,start
 ENDIF

 IFDEF TI82
 	org progstart
 ENDIF
